/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is BlueGriffon.
 *
 * The Initial Developer of the Original Code is
 * Disruptive Innovations SARL.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Daniel Glazman <daniel.glazman@disruptive-innovations.com>, Original author
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

// we store all globals in a gDialog object for convenience
Components.utils.import("resource://gre/modules/Services.jsm");

var gDialog = {};

function GetUIElements()
{
  var elts = document.getElementsByAttribute("id", "*");
  for (var i = 0; i < elts.length; i++)
  {
    var elt = elts.item(i);
    gDialog[ elt.getAttribute("id") ] = elt;
  }
}

document.documentElement
        .setAttribute("rtl",
                      Components.classes["@mozilla.org/chrome/chrome-registry;1"]
                        .getService(Components.interfaces.nsIXULChromeRegistry)
                        .isLocaleRTL("global"));

if (Services.prefs.getCharPref("bluegriffon.wysiwyg.theme") == "black" &&
    window.document.documentElement.getAttribute("forcecleartheme") != "true")
  window.document.documentElement.removeAttribute("cleartheme");
else
  window.document.documentElement.setAttribute("cleartheme", "true");

function ApplyWysiwygThemeChange(aDocument, aValue)
{
  var iframes = aDocument.querySelectorAll("iframe");
  for (var i = 0; i < iframes.length; i++) {
    var root = iframes[i].contentDocument.documentElement;
    if (aValue == "black" &&
        root.getAttribute("forcecleartheme") != "true")
      root.removeAttribute("cleartheme");
    else
      root.setAttribute("cleartheme", "true");
    if (root.id)
      iframes[i].contentDocument.persist(root.id, "cleartheme");

    ApplyWysiwygThemeChange(iframes[i].contentDocument, aValue)
  }
}

